diff -ur kaffe-1.0.7/config/mips/common.h kaffe-1.0.7.kevink_021001/config/mips/common.h
--- kaffe-1.0.7/config/mips/common.h	Wed Mar  7 11:38:17 2001
+++ kaffe-1.0.7.kevink_021001/config/mips/common.h	Sat Sep 28 00:53:07 2002
@@ -53,16 +53,17 @@
 	asm volatile(				\
 	"	.set	noreorder\n"		\
 	"	.set	mips2\n"		\
-	"1:	ll	%0, %3\n"		\
-	"	xor	%1, %0, %4\n"		\
-	"	sltiu	%1, %1, 1\n"		\
-	"	movn	%0, %5, %1\n"		\
-	"	sc	%0, %2\n"		\
+	"1:	ll	%0, %2\n"		\
+	"	bne	%0, %3,2f\n"		\
+	"	move	%0, $0\n"		\
+	"	move	%0, %4\n"		\
+	"	sc	%0, %1\n"		\
 	"	beqz	%0, 1b\n"		\
-	"	sync\n"				\
+	"	nop\n"				\
+	"2:\n"					\
 	"	.set	mips0\n"		\
 	"	.set	reorder\n"		\
-	: "=&r" (tmp), "=&r" (ret), "=m" (*(A))	\
+	: "=&r" (ret), "=m" (*(A))		\
 	: "m" (*(A)), "r" (O), "r" (N)		\
 	: "memory");				\
 	ret;					\
diff -ur kaffe-1.0.7/config/mips/jit3-mips.def kaffe-1.0.7.kevink_021001/config/mips/jit3-mips.def
--- kaffe-1.0.7/config/mips/jit3-mips.def	Sun Jun 17 18:39:11 2001
+++ kaffe-1.0.7.kevink_021001/config/mips/jit3-mips.def	Mon Jul 15 22:53:49 2002
@@ -25,10 +25,11 @@
 #endif
 
 #ifdef DEBUG
-extern int pc;
-int dbmsg = 0;
+extern uint pc;
+int jit_debug = 0;
+/* int dbmsg = 0; */
 #define	debug_name(x)	debug(x)
-#define	debug(x)	if (dbmsg) printf##x;fflush(stdout)
+#define	debug(x)	if (jit_debug) printf##x;fflush(stdout)
 static char* rnames[] = {
 	"i0",  "i1",  "i2",  "i3",  "i4",  "i5",  "i6",  "i7",
 	"i8",  "i9",  "i10", "i11", "i12", "i13", "i14", "i15",
diff -ur kaffe-1.0.7/config/mips/linux/md.c kaffe-1.0.7.kevink_021001/config/mips/linux/md.c
--- kaffe-1.0.7/config/mips/linux/md.c	Mon Sep  6 23:44:39 1999
+++ kaffe-1.0.7.kevink_021001/config/mips/linux/md.c	Fri Jul  5 14:46:49 2002
@@ -9,4 +9,6 @@
  * of this file. 
  */
 
+#if defined(TRANSLATOR)
 #include "mips/mips.c"
+#endif
diff -ur kaffe-1.0.7/config/mips/linux/md.h kaffe-1.0.7.kevink_021001/config/mips/linux/md.h
--- kaffe-1.0.7/config/mips/linux/md.h	Mon Sep  6 23:44:39 1999
+++ kaffe-1.0.7.kevink_021001/config/mips/linux/md.h	Tue Oct  1 08:31:08 2002
@@ -28,16 +28,16 @@
 /**/
 /* Signal handling */
 /**/
-#include <sigcontext.h>
+#include <signal.h>
 
 /* Define the entry into a signal handler */
-#define EXCEPTIONPROTO  int sig, int c1, int c2, int c3, int c4, int c5, int c6, int c7, struct sigcontext ctx
+#define EXCEPTIONPROTO  int sig, int cause, struct sigcontext *ctx
 
 /* Get the first exception frame from a signal handler */
 #define MIPS_FP 30
 #define EXCEPTIONFRAME(f, c) \
-	(f).return_frame = (void*)(c).sc_regs[MIPS_FP]; \
-	(f).return_pc = (void*)(c).sc_pc
+	(f).return_frame = (void*)(c)->sc_regs[MIPS_FP]; \
+	(f).return_pc = (void*)(c)->sc_pc
 
 
 #endif
diff -ur kaffe-1.0.7/config/mips/o32-sysdepCallMethod.h kaffe-1.0.7.kevink_021001/config/mips/o32-sysdepCallMethod.h
--- kaffe-1.0.7/config/mips/o32-sysdepCallMethod.h	Thu Apr 15 20:19:31 1999
+++ kaffe-1.0.7.kevink_021001/config/mips/o32-sysdepCallMethod.h	Tue Oct  1 08:17:59 2002
@@ -123,61 +123,66 @@
 #endif
 
   case 4:
-      if (calltype[0] != D) {
+      if ((calltype[0] != D) && (calltype[0] != F)) {
 	  a3 = callargs[3].i;
-	  goto allint_3;
+	  a2 = callargs[2].i;
+	  a1 = callargs[1].i;
+	  a0 = callargs[0].i;
+	  goto alldone;
       }
       
       if (calltype[2] == D) {
 	  d2 = callargs[2].d;
-	  goto alldouble_2;
+	  if(calltype[0] == D) d0 = callargs[0].d;
+	  else f0 = callargs[0].f;
+	  goto alldone;
       }
 
       a3 = callargs[3].i;
-      goto int_double;
 
   case 3:
-      if (calltype[0] != D) {
-      allint_3:
+      if ((calltype[0] != D) && (calltype[0] != F)) {
 	  a2 = callargs[2].i;
-	  goto testfloat_2;
+	  a1 = callargs[1].i;
+	  a0 = callargs[0].i;
+	  goto alldone;
       }
       
-      if (calltype[2] == F)
+      if ((calltype[2] == F) && (calltype[0] == D))
 	  f2 = callargs[2].f;
       else {
-      int_double:
 	  a2 = callargs[2].i;
       }
-      goto alldouble_2;
 
   case 2:
       if (calltype[0] == D) {
-      alldouble_2:
 	  d0=callargs[0].d;
+	  goto alldone;
       } else {
-      testfloat_2:
 	  if (calltype[0] != F) {
 	      a1 = callargs[1].i;
-	      goto allint_1;
+	      a0 = callargs[0].i;
+	      goto alldone;
 	  }
 
-	  if (calltype[1] == F)
+	  if (calltype[1] == F) {
 	      f2=callargs[1].f;
-	  else
+	      f0=callargs[0].f;
+	      goto alldone;
+	  } else {
 	      a1=callargs[1].i;
-	  goto allfloat_1;
+	      f0=callargs[0].f;
+	      goto alldone;
+	  }
       }
 
   case 1:
       if (calltype[0] == F) {
-      allfloat_1:
 	  f0=callargs[0].f;
       } else {
-      allint_1:
 	  a0=callargs[0].i;
       }
-
+alldone:
   case 0:
 #ifndef LONG_SYSDEP
   noargs:
diff -ur kaffe-1.0.7/config/mips/threads.h kaffe-1.0.7.kevink_021001/config/mips/threads.h
--- kaffe-1.0.7/config/mips/threads.h	Mon Mar 12 13:50:47 2001
+++ kaffe-1.0.7.kevink_021001/config/mips/threads.h	Mon Jul 15 19:23:07 2002
@@ -32,9 +32,11 @@
  * This is the offset into the setjmp buffer where the stack pointer is
  * stored.  This may be different with different OSes.
  */
+#if !defined(SP_OFFSET)
+
 #if !defined(_MIPS_SIM) || (_MIPS_SIM == _MIPS_SIM_ABI32)
-#define SP_OFFSET               2
-#define FP_OFFSET               13
+#define SP_OFFSET               1
+#define FP_OFFSET		10
 #endif
 
 #if (_MIPS_SIM == _MIPS_SIM_ABI64 || _MIPS_SIM == _MIPS_SIM_NABI32)
@@ -42,4 +44,5 @@
 #define FP_OFFSET               23
 #endif
 
+#endif /* SP_OFFSET */
 #endif
diff -ur kaffe-1.0.7/kaffe/kaffevm/support.c kaffe-1.0.7.kevink_021001/kaffe/kaffevm/support.c
--- kaffe-1.0.7/kaffe/kaffevm/support.c	Thu May 30 00:58:44 2002
+++ kaffe-1.0.7.kevink_021001/kaffe/kaffevm/support.c	Tue Oct  1 08:18:28 2002
@@ -332,7 +332,17 @@
 # if NO_HOLES
 #  error "ALIGN_AT_64bits is incompatible with NO_HOLES"
 # endif
-# define ENSURE_ALIGN64(DO) do { if (call.callsize[i] == 2 && (i & 1)) { call.callsize[i] = 0; call.calltype[i] = 'I'; DO; ++i; ++s; call.callsize[i] = 2; } } while (0)
+# define ENSURE_ALIGN64(DO) do { \
+		if (call.callsize[i] == 2 && (i & 1)) { \
+			char tmptype = call.calltype[i]; \
+			call.callsize[i] = 0; \
+			call.calltype[i] = 'I'; \
+			DO; \
+			++i; ++s; \
+			call.calltype[i] = tmptype; \
+			call.callsize[i] = 2; \
+		} \
+	} while (0)
 #else
 # define ENSURE_ALIGN64(DO) do {} while (0)
 #endif
